from OpenGL.GL import *

import tileset
import level
import triggers
import player
import spider
import tile
import animatedobject
import projectile
import menu

class World:
	def __init__(self,tBox,aBox):
		self.xpos = 0
		self.ypos = 0
		self.tBox = tBox
		self.aBox = aBox
		self.currentLevel = 'AF'
		self.triggers = {}
		# Load tilesets
		ts = tileset.Tileset(self.tBox)
		ts.load("test")	
		# Load maps
		self.levels = {}
#		self.levels['test'] = level.Level("testlevel",ts)	
#		self.levels['test2'] = level.Level("testlevel2",ts)	
		self.levels['AA'] = level.Level("AA",ts)	
		self.levels['AB'] = level.Level("AB",ts)	
		self.levels['AC'] = level.Level("AC",ts)	
		self.levels['AD'] = level.Level("AD",ts)	
		self.levels['AE'] = level.Level("AE",ts)	
		self.levels['AF'] = level.Level("AF",ts)	
		self.levels['AG'] = level.Level("AG",ts)	
		self.levels['AH'] = level.Level("AH",ts)	
		self.levels['AI'] = level.Level("AI",ts)	
		self.levels['AJ'] = level.Level("AJ",ts)	

		self.shots = []


		self.triggerTile = tile.special(self.tBox.get("test"))	
		# Setup triggers
		triggers.init(self)

		# Add player
		self.player = player.Player()
		self.player.setAnimation("running-s",0.03)
		self.player.posx = 5 
		self.player.posy = 5 
		self.player.visible = True

		for v in self.levels.values():
			v.objects.append(self.player)

		# Create inventory menu
		self.imenu = menu.Menu()
		self.imenu.setTextureBox(self.tBox)

		# Create inventory
		self.inv = []
		self.addToInventory('leash')
		self.addToInventory('pda')

	def addToInventory(self,item):
		self.inv.append(item)
		self.imenu.addMenuItem(item,item)

	def addTrigger(self, level, letter, trigger, args, ttile):
		for t in self.levels[level].triggers[letter]:
			self.triggers[(level,t)] = (trigger, args) 
			(x,y) = t 
			self.levels[level].levelData[x][y] = ttile

	def checkTrigger(self,pos):
		trig = self.triggers.get((self.currentLevel, pos))
		if trig:
			print trig
			fname, args = trig
			getattr(triggers,fname)(self,args)

	def update(self, movx, movy, action, timeDelta):
		
		self.player.update(movx,movy,timeDelta,self)
		self.xpos = self.player.posx
		self.ypos = self.player.posy
		self.checkTrigger((int(self.xpos), int(self.ypos)))
#		for s in self.shots:
#			if ((self.player.posx-s.posx)**2 + (self.player.posy-s.posy)**2)**0.5 > 5:
#				self.shots.remove(s)	
#			else:
#				s.update(timeDelta,self)

#		if action == 'shot':
#			shot = projectile.PlayerProjectile(self.player.posx,self.player.posy,self.player.xdelta,self.player.ydelta)
#			self.shots.append(shot)
#
			

	def render(self):

			glPushMatrix()
			# Setup isometric view
			glRotatef(60,1,0,0)
			glRotatef(45,0,0,-1)
			# Scroll screen 
			glTranslatef(-self.xpos, -self.ypos, 0) 
			# Render world

			self.levels[self.currentLevel].render()
			glPopMatrix()

			# Restore 2d view


